# ChunkCodecLibZlib

This package implements the ChunkCodec interface for the following encoders and decoders
using the zlib C library <https://www.zlib.net/>

1. `ZlibCodec`, `ZlibEncodeOptions`, `ZlibDecodeOptions`
2. `DeflateCodec`, `DeflateEncodeOptions`, `DeflateDecodeOptions`
3. `GzipCodec`, `GzipEncodeOptions`, `GzipDecodeOptions`

## Example

```julia-repl
julia> using ChunkCodecLibZlib

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> compressed_data = encode(GzipEncodeOptions(;level=6), data);

julia> decompressed_data = decode(GzipCodec(), compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

"""
    LibzDecodingError(msg)

Error for data that cannot be decoded.
"""
struct LibzDecodingError <: DecodingError
    msg::String
end

function Base.showerror(io::IO, err::LibzDecodingError)
    print(io, "LibzDecodingError: ")
    print(io, err.msg)
    nothing
end

"""
    struct ZlibDecodeOptions <: DecodeOptions
    ZlibDecodeOptions(; kwargs...)

zlib decompression using libzlib: https://www.zlib.net/

This is the zlib format described in RFC 1950

# Keyword Arguments

- `codec::ZlibCodec=ZlibCodec()`
"""
struct ZlibDecodeOptions <: DecodeOptions
    codec::ZlibCodec
end
function ZlibDecodeOptions(;
        codec::ZlibCodec=ZlibCodec(),
        kwargs...
    )
    ZlibDecodeOptions(codec)
end

"""
    struct DeflateDecodeOptions <: DecodeOptions
    DeflateDecodeOptions(; kwargs...)

deflate decompression using libzlib: https://www.zlib.net/

This is the deflate format described in RFC 1951

# Keyword Arguments

- `codec::DeflateCodec=DeflateCodec()`
"""
struct DeflateDecodeOptions <: DecodeOptions
    codec::DeflateCodec
end
function DeflateDecodeOptions(;
        codec::DeflateCodec=DeflateCodec(),
        kwargs...
    )
    DeflateDecodeOptions(codec)
end


"""
    struct GzipDecodeOptions <: DecodeOptions
    GzipDecodeOptions(; kwargs...)

gzip decompression using libzlib: https://www.zlib.net/

This is the gzip (.gz) format described in RFC 1952

# Keyword Arguments

- `codec::GzipCodec=GzipCodec()`
"""
struct GzipDecodeOptions <: DecodeOptions
    codec::GzipCodec
end
function GzipDecodeOptions(;
        codec::GzipCodec=GzipCodec(),
        kwargs...
    )
    GzipDecodeOptions(codec)
end

can_concatenate(::GzipDecodeOptions) = true

const _AllDecodeOptions = Union{ZlibDecodeOptions, DeflateDecodeOptions, GzipDecodeOptions}

is_thread_safe(::_AllDecodeOptions) = true

function try_find_decoded_size(::_AllDecodeOptions, src::AbstractVector{UInt8})::Nothing
    nothing
end
function try_decode!(d::_AllDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    try_resize_decode!(d, dst, src, Int64(length(dst)))
end

function try_resize_decode!(d::_AllDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    src_left::Int64 = src_size
    dst_left::Int64 = dst_size
    check_contiguous(dst)
    check_contiguous(src)
    if isempty(src)
        throw(LibzDecodingError("unexpected end of stream"))
    end
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    # This outer loop is to decode a concatenation of multiple compressed streams.
    # If `can_concatenate(d)` is false, this outer loop doesn't rerun.
    while true
        stream = ZStream()
        inflateInit2(stream, _windowBits(d.codec))
        try
            # This inner loop is needed because libz can work on at most 
            # 2^32 - 1 bytes at a time.
            while true
                # dst may get resized, so cconvert needs to be redone on each iteration.
                cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
                GC.@preserve cconv_src cconv_dst begin
                    src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
                    dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
                    start_avail_in = clamp(src_left, Cuint)
                    start_avail_out = clamp(dst_left, Cuint)
                    stream.avail_in = start_avail_in
                    stream.avail_out = start_avail_out
                    stream.next_in = src_p + (src_size - src_left)
                    stream.next_out = dst_p + (dst_size - dst_left)
                    # @info (;stream.avail_in, stream.avail_out)
                    ret = ccall(
                        (:inflate, libz),
                        Cint,
                        (Ref{ZStream}, Cint),
                        stream, Z_NO_FLUSH,
                    )
                    # @info (;ret, stream.avail_in, stream.avail_out)
                    if ret == Z_OK || ret == Z_STREAM_END || ret == Z_BUF_ERROR
                        @assert stream.avail_in ≤ start_avail_in
                        @assert stream.avail_out ≤ start_avail_out
                        dst_left -= start_avail_out - stream.avail_out
                        src_left -= start_avail_in - stream.avail_in
                        @assert src_left ∈ 0:src_size
                        @assert dst_left ∈ 0:dst_size
                    end
                    if ret == Z_OK || ret == Z_BUF_ERROR
                        if (
                                iszero(stream.avail_out) && !iszero(dst_left) ||
                                iszero(stream.avail_in) && !iszero(src_left) ||
                                !iszero(src_left) && !iszero(dst_left)
                            )
                            # there must be progress
                            @assert ret != Z_BUF_ERROR
                            @assert stream.avail_in < start_avail_in || stream.avail_out < start_avail_out
                        elseif iszero(dst_left) # needs more output
                            local next_size = grow_dst!(dst, max_size)
                            if isnothing(next_size)
                                return NOT_SIZE
                            end
                            dst_left += next_size - dst_size
                            dst_size = next_size
                            @assert dst_left > 0
                        else
                            @assert iszero(src_left) && !iszero(stream.avail_out)
                            throw(LibzDecodingError("unexpected end of stream"))
                        end
                    elseif ret == Z_STREAM_END
                        if iszero(src_left)
                            # yay done return decompressed size
                            real_dst_size = dst_size - dst_left
                            @assert real_dst_size ∈ 0:length(dst)
                            return real_dst_size
                        else
                            if can_concatenate(d)
                                # try and decompress next stream if the decoder can_concatenate
                                # there must be progress
                                @assert stream.avail_in < start_avail_in || stream.avail_out < start_avail_out
                                break
                            else
                                # Otherwise, throw an error
                                throw(LibzDecodingError("unexpected $(src_left) bytes after stream"))
                            end
                        end
                    elseif ret == Z_STREAM_ERROR
                        error("Z_STREAM_ERROR this should be unreachable")
                    elseif ret == Z_NEED_DICT
                        throw(LibzDecodingError("Z_NEED_DICT: a preset dictionary is needed at this point"))
                    elseif ret == Z_DATA_ERROR
                        if stream.msg == C_NULL
                            throw(LibzDecodingError("unknown Z_DATA_ERROR"))
                        else
                            throw(LibzDecodingError(unsafe_string(stream.msg)))
                        end
                    elseif ret == Z_MEM_ERROR
                        throw(OutOfMemoryError())
                    else
                        error("unknown libz error code: $(ret)")
                    end
                end
            end
        finally
            inflateEnd(stream)
        end
    end
end

# This file contains tests that require a large amount of memory (at least 15 GB)
# and take a long time to run. The tests are designed to check the 
# compression and decompression functionality of the ChunkCodecLibZlib package 
# with very large inputs. These tests are not run with CI

using ChunkCodecLibZlib:
    ChunkCodecLibZlib,
    GzipCodec,
    GzipEncodeOptions,
    ZlibEncodeOptions,
    ZlibCodec,
    encode,
    decode
using Test: @testset, @test

@testset "Big Memory Tests" begin
    Sys.WORD_SIZE == 64 || error("tests require 64 bit word size")
    @info "compressing zeros"
    let
        local n = 2^32-327671
        local u = decode(ZlibCodec(), encode(ZlibEncodeOptions(;level=0), zeros(UInt8, n)); size_hint=n, max_size=n)
        all_zero = all(iszero, u)
        len_n = length(u) == n
        @test all_zero && len_n
    end
    for n in (2^32 - 1, 2^32, 2^32 +1, 2^33)
        @info "compressing"
        local c = encode(GzipEncodeOptions(), zeros(UInt8, n))
        @info "decompressing"
        local u = decode(GzipCodec(), c; size_hint=n)
        c = nothing
        all_zero = all(iszero, u)
        len_n = length(u) == n
        @test all_zero && len_n
    end

    @info "compressing random"
    for n in (2^32 - 1, 2^32, 2^32 +1)
        local u = rand(UInt8, n)
        @info "compressing"
        local c = encode(GzipEncodeOptions(), u)
        @info "decompressing"
        local u2 = decode(GzipCodec(), c)
        c = nothing
        are_equal = u == u2
        @test are_equal
    end

    @info "decompressing huge concatenation"
    uncompressed = rand(UInt8, 2^20)
    @info "compressing"
    compressed = encode(GzipEncodeOptions(), uncompressed)
    total_compressed = UInt8[]
    sizehint!(total_compressed, length(compressed)*2^12)
    total_uncompressed = UInt8[]
    sizehint!(total_uncompressed, length(uncompressed)*2^12)
    for i in 1:2^12
        append!(total_uncompressed, uncompressed)
        append!(total_compressed, compressed)
    end
    @test length(total_compressed) > 2^32
    @info "decompressing"
    @test total_uncompressed == decode(GzipCodec(), total_compressed; size_hint=length(total_uncompressed))
end

const level_docs = """
- `level::Integer=-1`: The compression level must be -1, or between 0 and 9.

  1 gives best speed, 9 gives best compression, 0 gives no compression at all
  (the input data is simply copied a block at a time). -1
  requests a default compromise between speed and compression (currently
  equivalent to level 6).
"""

const strategy_docs = """
- `strategy::Integer=$(Z_DEFAULT_STRATEGY)`: The compression strategy must be between $(Z_DEFAULT_STRATEGY) and $(Z_FIXED).

  The strategy parameter is used to tune the compression algorithm. It only
  affects the compression ratio but not the correctness of the compressed
  output even if it is not set appropriately.

  - $(Z_DEFAULT_STRATEGY) (`Z_DEFAULT_STRATEGY`) is used for normal data.
  - $(Z_FILTERED) (`Z_FILTERED`) is used for data produced by a filter (or predictor).
    Filtered data consists mostly of small values with a somewhat random
    distribution. In this case, the compression algorithm is tuned to compress
    them better. The effect of `Z_FILTERED` is to force more Huffman coding
    and less string matching; it is somewhat intermediate between
    `Z_DEFAULT_STRATEGY` and `Z_HUFFMAN_ONLY`.
  - $(Z_HUFFMAN_ONLY) (`Z_HUFFMAN_ONLY`) forces Huffman encoding only (no string match).
  - $(Z_RLE) (`Z_RLE`) limits match distances to one (run-length encoding). `Z_RLE`
    is designed to be almost as fast as `Z_HUFFMAN_ONLY`, but gives better
    compression for PNG image data.
  - $(Z_FIXED) (`Z_FIXED`) prevents the use of dynamic Huffman codes, allowing for a
    simpler decoder for special applications.
"""

"""
    struct ZlibEncodeOptions <: EncodeOptions
    ZlibEncodeOptions(; kwargs...)

zlib compression using libzlib: https://www.zlib.net/

This is the zlib format described in RFC 1950

# Keyword Arguments

- `codec::ZlibCodec=ZlibCodec()`
$(level_docs)
$(strategy_docs)
"""
struct ZlibEncodeOptions <: EncodeOptions
    codec::ZlibCodec
    level::Int32
    strategy::Int32
end
function ZlibEncodeOptions(;
        codec::ZlibCodec=ZlibCodec(),
        level::Integer=-1,
        strategy::Integer=Z_DEFAULT_STRATEGY,
        kwargs...
    )
    check_in_range(Z_DEFAULT_STRATEGY:Z_FIXED; strategy)
    ZlibEncodeOptions(
        codec,
        Int32(clamp(level, -1, 9)),
        Int32(strategy),
    )
end

"""
    struct DeflateEncodeOptions <: EncodeOptions
    DeflateEncodeOptions(; kwargs...)

deflate compression using libzlib: https://www.zlib.net/

This is the deflate format described in RFC 1951

# Keyword Arguments

- `codec::DeflateCodec=DeflateCodec()`
$(level_docs)
$(strategy_docs)
"""
struct DeflateEncodeOptions <: EncodeOptions
    codec::DeflateCodec
    level::Int32
    strategy::Int32
end
function DeflateEncodeOptions(;
        codec::DeflateCodec=DeflateCodec(),
        level::Integer=-1,
        strategy::Integer=Z_DEFAULT_STRATEGY,
        kwargs...
    )
    check_in_range(Z_DEFAULT_STRATEGY:Z_FIXED; strategy)
    DeflateEncodeOptions(
        codec,
        Int32(clamp(level, -1, 9)),
        Int32(strategy),
    )
end

"""
    struct GzipEncodeOptions <: EncodeOptions
    GzipEncodeOptions(; kwargs...)

gzip compression using libzlib: https://www.zlib.net/

This is the gzip (.gz) format described in RFC 1952

# Keyword Arguments

- `codec::GzipCodec=GzipCodec()`
$(level_docs)
$(strategy_docs)
"""
struct GzipEncodeOptions <: EncodeOptions
    codec::GzipCodec
    level::Int32
    strategy::Int32
end
function GzipEncodeOptions(;
        codec::GzipCodec=GzipCodec(),
        level::Integer=-1,
        strategy::Integer=Z_DEFAULT_STRATEGY,
        kwargs...
    )
    check_in_range(Z_DEFAULT_STRATEGY:Z_FIXED; strategy)
    GzipEncodeOptions(
        codec,
        Int32(clamp(level, -1, 9)),
        Int32(strategy),
    )
end

const _AllEncodeOptions = Union{ZlibEncodeOptions, DeflateEncodeOptions, GzipEncodeOptions}

is_thread_safe(::_AllEncodeOptions) = true

# Modified from the deflateBound function in zlib/deflate.c
# Since the default gzip header, windowBits, and memLevel are always
# used in this package, the code can be simplified.
# If alternate settings are used this must be modified.
function encode_bound(e::_AllEncodeOptions, src_size::Int64)::Int64
    wraplen = _wraplen(e)
    clamp(
        widen(src_size) +
        widen(src_size>>12 + src_size>>14 + src_size>>25 + Int64(7) + wraplen),
        Int64,
    )
end
_wraplen(::ZlibEncodeOptions)    = Int64(6)
_wraplen(::DeflateEncodeOptions) = Int64(0)
_wraplen(::GzipEncodeOptions)    = Int64(18)

# max to prevent overflows in encode_bound
# From ChunkCodecTests.find_max_decoded_size(::EncodeOptions)
_max_decoded_size(::ZlibEncodeOptions)::Int64 = 0x7ff60087fa602c72
_max_decoded_size(::DeflateEncodeOptions)::Int64 = 0x7ff60087fa602c78
_max_decoded_size(::GzipEncodeOptions)::Int64 = 0x7ff60087fa602c66

decoded_size_range(e::_AllEncodeOptions) = Int64(0):Int64(1):_max_decoded_size(e)

function try_encode!(e::_AllEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    # -15: deflate, 15: zlib, 15+16: gzip
    # smaller windowBits might break encode bound
    windowBits = _windowBits(e.codec)
    @assert windowBits ∈ (-15, 15, 15+16)
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    if iszero(dst_size)
        return NOT_SIZE
    end
    stream = ZStream()
    deflateInit2(stream, e.level, windowBits, e.strategy)
    try
        # deflate loop
        cconv_src = Base.cconvert(Ptr{UInt8}, src)
        cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
        GC.@preserve cconv_src cconv_dst begin
            src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
            dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
            stream.next_in = src_p
            stream.next_out = dst_p
            src_left::Int64 = src_size
            dst_left::Int64 = dst_size
            while true
                start_avail_in = clamp(src_left, Cuint)
                start_avail_out = clamp(dst_left, Cuint)
                stream.avail_in = start_avail_in
                stream.avail_out = start_avail_out
                @assert !iszero(stream.avail_out)
                action = if stream.avail_in == src_left
                    Z_FINISH
                else
                    Z_NO_FLUSH
                end
                ret = ccall(
                    (:deflate, libz),
                    Cint,
                    (Ref{ZStream}, Cint),
                    stream, action,
                )
                @assert ret != Z_STREAM_ERROR # state not clobbered
                @assert stream.avail_in ≤ start_avail_in
                @assert stream.avail_out ≤ start_avail_out
                # there must be progress
                @assert stream.avail_in < start_avail_in || stream.avail_out < start_avail_out
                src_left -= start_avail_in - stream.avail_in
                dst_left -= start_avail_out - stream.avail_out
                @assert src_left ∈ 0:src_size
                @assert dst_left ∈ 0:dst_size
                @assert stream.next_in == src_p + (src_size - src_left)
                @assert stream.next_out == dst_p + (dst_size - dst_left)
                if ret == Z_STREAM_END
                    # yay done just return compressed size
                    @assert dst_left ∈ 0:dst_size
                    @assert iszero(src_left)
                    return dst_size - dst_left
                end
                if iszero(dst_left)
                    # no more space, but not Z_STREAM_END
                    return NOT_SIZE
                end
                @assert ret == Z_OK
            end
        end
    finally
        deflateEnd(stream)
    end
end

# Constants and c wrapper functions ported to Julia from zlib.h https://github.com/madler/zlib/blob/v1.3.1/zlib.h

const ZLIB_VERSION = "1.3.1"

# constants
const Z_NO_FLUSH      = 0
const Z_PARTIAL_FLUSH = 1
const Z_SYNC_FLUSH    = 2
const Z_FULL_FLUSH    = 3
const Z_FINISH        = 4
const Z_BLOCK         = 5
const Z_TREES         = 6
# Allowed flush values; see deflate() and inflate() below for details 

const Z_OK            = 0
const Z_STREAM_END    = 1
const Z_NEED_DICT     = 2
const Z_ERRNO         = (-1)
const Z_STREAM_ERROR  = (-2)
const Z_DATA_ERROR    = (-3)
const Z_MEM_ERROR     = (-4)
const Z_BUF_ERROR     = (-5)
const Z_VERSION_ERROR = (-6)
# Return codes for the compression/decompression functions. Negative values
# are errors, positive values are used for special but normal events.

const Z_NO_COMPRESSION       = 0
const Z_BEST_SPEED           = 1
const Z_BEST_COMPRESSION     = 9
const Z_DEFAULT_COMPRESSION  = (-1)
# compression levels

const Z_FILTERED            = 1
const Z_HUFFMAN_ONLY        = 2
const Z_RLE                 = 3
const Z_FIXED               = 4
const Z_DEFAULT_STRATEGY    = 0
# compression strategy; see deflateInit2() below for details

const Z_DEFLATED   = 8
# The deflate compression method (the only one supported in this version)

@assert typemax(Csize_t) ≥ typemax(Cuint)

function zalloc(::Ptr{Cvoid}, items::Cuint, size::Cuint)::Ptr{Cvoid}
    s, f = Base.Checked.mul_with_overflow(items, size)
    if f
        C_NULL
    else
        ccall(:jl_malloc, Ptr{Cvoid}, (Csize_t,), s%Csize_t)
    end
end
zfree(::Ptr{Cvoid}, address::Ptr{Cvoid}) = ccall(:jl_free, Cvoid, (Ptr{Cvoid},), address)

mutable struct ZStream
    next_in::Ptr{Cuchar}  # next input byte
    avail_in::Cuint       # number of bytes available at next_in
    total_in::Culong      # total number of input bytes read so far

    next_out::Ptr{Cuchar} # next output byte will go here
    avail_out::Cuint      # remaining free space at next_out
    total_out::Culong     # total number of bytes output so far

    msg::Ptr{Cchar}       # last error message, NULL if no error
    state::Ptr{Cvoid}     # not visible by applications

    zalloc::Ptr{Cvoid}    # used to allocate the internal state
    zfree::Ptr{Cvoid}     # used to free the internal state
    opaque::Ptr{Cvoid}    # private data object passed to zalloc and zfree

    data_type::Cint       # best guess about the data type: binary or text
                          # for deflate, or the decoding state for inflate
    adler::Culong         # Adler-32 or CRC-32 value of the uncompressed data
    reserved::Culong      # reserved for future use

    function ZStream()
        new(
            C_NULL, 0, 0,
            C_NULL, 0, 0,
            C_NULL, C_NULL,
            @cfunction(zalloc, Ptr{Cvoid}, (Ptr{Cvoid}, Cuint, Cuint)),
            @cfunction(zfree, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid})),
            C_NULL,
            0,
            0, 0,
        )
    end
end

function deflateInit2(stream::ZStream, level::Cint, windowBits::Cint, strategy::Cint)
    memLevel = Cint(8) # default
    ret = @ccall libz.deflateInit2_(
        stream::Ref{ZStream},
        level::Cint,
        Z_DEFLATED::Cint,
        windowBits::Cint,
        memLevel::Cint,
        strategy::Cint,
        ZLIB_VERSION::Cstring,
        sizeof(ZStream)::Cint,
    )::Cint
    if ret != Z_OK
        if ret == Z_MEM_ERROR
            throw(OutOfMemoryError())
        elseif ret == Z_STREAM_ERROR
            error("Z_STREAM_ERROR: invalid parameter") # this should be validated before this
        elseif ret == Z_VERSION_ERROR
            error("Z_VERSION_ERROR: zlib version is incompatible")
        else
            error("Unknown zlib error code: $(ret)")
        end
    end
    nothing
end

function deflateEnd(stream::ZStream)
    # free libz stream state if needed
    if stream.state != C_NULL
        ccall(
            (:deflateEnd, libz),
            Cint,
            (Ref{ZStream},),
            stream,
        )
    end
    nothing
end

function inflateInit2(stream::ZStream, windowBits::Cint)
    # indicate that no input data is being provided for future zlib compat
    stream.next_in = C_NULL
    stream.avail_in = 0
    ret = ccall(
        (:inflateInit2_, libz),
        Cint,
        (Ref{ZStream}, Cint, Cstring, Cint),
        stream, windowBits, ZLIB_VERSION, sizeof(ZStream),
    )
    if ret != Z_OK
        if ret == Z_MEM_ERROR
            throw(OutOfMemoryError())
        elseif ret == Z_STREAM_ERROR
            error("Z_STREAM_ERROR: invalid parameter")
        elseif ret == Z_VERSION_ERROR
            error("Z_VERSION_ERROR: zlib version is incompatible")
        else
            error("Unknown zlib error code: $(ret)")
        end
    end
    nothing
end

function inflateEnd(stream::ZStream)
    # free stream state if needed
    if stream.state != C_NULL
        ccall(
            (:inflateEnd, libz),
            Cint,
            (Ref{ZStream},),
            stream,
        )
    end
    nothing
end


# The following is the original license info from zlib.h

#= zlib.h -- interface of the 'zlib' general purpose compression library
  version 1.3.1, January 22nd, 2024

  Copyright (C) 1995-2024 Jean-loup Gailly and Mark Adler

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Jean-loup Gailly        Mark Adler
  jloup@gzip.org          madler@alumni.caltech.edu


  The data format used by the zlib library is described by RFCs (Request for
  Comments) 1950 to 1952 in the files http://tools.ietf.org/html/rfc1950
  (zlib format), rfc1951 (deflate format) and rfc1952 (gzip format).
=#

using Random: Random
using ChunkCodecCore: encode_bound, decoded_size_range, encode, decode
using ChunkCodecLibZlib:
    ChunkCodecLibZlib,
    ZlibCodec,
    ZlibEncodeOptions,
    ZlibDecodeOptions,
    DeflateCodec,
    DeflateEncodeOptions,
    DeflateDecodeOptions,
    GzipCodec,
    GzipEncodeOptions,
    GzipDecodeOptions,
    LibzDecodingError
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibZlib; persistent_tasks = false)

Random.seed!(1234)

tests = [
    (
        ZlibCodec,
        ZlibEncodeOptions,
        ZlibDecodeOptions,
    ),
    (
        DeflateCodec,
        DeflateEncodeOptions,
        DeflateDecodeOptions,
    ),
    (
        GzipCodec,
        GzipEncodeOptions,
        GzipDecodeOptions,
    ),
]

@testset "tests for $(codec)" for (codec, encode_opt, decode_opt) in tests
    @testset "encode_bound" begin
        local a = last(decoded_size_range(encode_opt()))
        @test encode_bound(encode_opt(), a) == typemax(Int64) - 1
    end
    @testset "default" begin
        test_codec(codec(), encode_opt(), decode_opt(); trials=50)
    end
    @testset "level options" begin
        # level should get clamped to -1 to 9
        @test encode_opt(; level=-10).level == -1
        @test encode_opt(; level=10).level == 9
        @test encode_opt(; level=-2).level == -1
        for i in -1:9
            test_codec(codec(), encode_opt(; level=i), decode_opt(); trials=5)
        end
    end
    @testset "strategy options" begin
        # strategy must be in 0:4
        @test_throws ArgumentError encode_opt(; strategy=-1)
        @test_throws ArgumentError encode_opt(; strategy=5)
        for i in 0:4
            @test encode_opt(; strategy=i).strategy == i
            test_codec(codec(), encode_opt(; strategy=i), decode_opt(); trials=5)
        end
    end
    @testset "combined options" begin
        for level in -1:9
            for strategy in 0:4
                test_codec(codec(), encode_opt(;level, strategy), decode_opt(); trials=5)
            end
        end
    end
    @testset "unexpected eof" begin
        local d = decode_opt()
        local u = [0x00, 0x01, 0x02]
        local c = encode(encode_opt(), u)
        @test decode(d, c) == u
        for i in 1:length(c)
            @test_throws LibzDecodingError("unexpected end of stream") decode(d, c[1:i-1])
        end
    end
end
@testset "unexpected eof with concatenation" begin
    e = GzipEncodeOptions()
    d = GzipDecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    @test_throws LibzDecodingError decode(d, u)
    c[end] ⊻= 0xFF
    @test_throws LibzDecodingError decode(d, c)
    @test_throws LibzDecodingError decode(d, [encode(e, u); c])
    @test_throws LibzDecodingError decode(d, [encode(e, u); 0x00])
end
@testset "$(codec) doesn't support concatenation" for (codec, encode_opt, decode_opt) in tests[1:2]
    e = encode_opt()
    d = decode_opt()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    @test_throws LibzDecodingError decode(d, u)
    c[begin] ⊻= 0xFF
    @test_throws LibzDecodingError decode(d, c)
    @test_throws LibzDecodingError("unexpected $(length(c)) bytes after stream") decode(d, [encode(e, u); c])
    @test_throws LibzDecodingError("unexpected $(length(c)) bytes after stream") decode(d, [encode(e, u); encode(e, u)])
    @test_throws LibzDecodingError("unexpected 1 bytes after stream") decode(d, [encode(e, u); 0x00])
end
@testset "Z_NEED_DICT error" begin
    @test_throws(
        LibzDecodingError("Z_NEED_DICT: a preset dictionary is needed at this point"),
        decode(
            ZlibDecodeOptions(),
            UInt8[0x78, 0xbb, 0x00, 0x00, 0x00, 0x01, 0x03, 0x00, 0x00, 0x00, 0x00, 0x01],
        )
    )
end
@testset "errors" begin
    @test sprint(Base.showerror, LibzDecodingError("test error message")) ==
        "LibzDecodingError: test error message"
end

module ChunkCodecLibZlib

using Zlib_jll: libz

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_contiguous,
    check_in_range,
    grow_dst!,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    decode_options,
    can_concatenate,
    try_decode!,
    try_resize_decode!,
    try_encode!,
    encode_bound,
    is_thread_safe,
    try_find_decoded_size,
    decoded_size_range

export ZlibCodec,
    DeflateCodec,
    GzipCodec,
    ZlibEncodeOptions,
    DeflateEncodeOptions,
    GzipEncodeOptions,
    ZlibDecodeOptions,
    DeflateDecodeOptions,
    GzipDecodeOptions,
    LibzDecodingError

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode


include("libz.jl")

"""
    struct ZlibCodec <: Codec
    ZlibCodec()

zlib compression using libzlib: https://www.zlib.net/

This is the zlib format described in RFC 1950

See also [`ZlibEncodeOptions`](@ref) and [`ZlibDecodeOptions`](@ref)
"""
struct ZlibCodec <: Codec
end
decode_options(::ZlibCodec) = ZlibDecodeOptions()

# windowBits setting for the codec
_windowBits(::ZlibCodec) = Cint(15)

"""
    struct DeflateCodec <: Codec
    DeflateCodec()

deflate compression using libzlib: https://www.zlib.net/

This is the deflate format described in RFC 1951

See also [`DeflateEncodeOptions`](@ref) and [`DeflateDecodeOptions`](@ref)
"""
struct DeflateCodec <: Codec
end
decode_options(::DeflateCodec) = DeflateDecodeOptions()

# windowBits setting for the codec
_windowBits(::DeflateCodec) = Cint(-15)

"""
    struct GzipCodec <: Codec
    GzipCodec()

gzip compression using libzlib: https://www.zlib.net/

This is the gzip (.gz) format described in RFC 1952

See also [`GzipEncodeOptions`](@ref) and [`GzipDecodeOptions`](@ref)
"""
struct GzipCodec <: Codec
end
decode_options(::GzipCodec) = GzipDecodeOptions()

# windowBits setting for the codec
_windowBits(::GzipCodec) = Cint(15+16)

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibZlib
